set echo on
set numwidth 10
clear screen
select deptno
     , empno
     , job
     , mgr
     , ename
     , sum(sal)
  from emp
 group by deptno
     , rollup (empno)
     , cube (job,mgr)
     , grouping sets ( ename )
 order by deptno
     , ename
     , empno
     , job
     , mgr
/
pause
select deptno
     , empno
     , job
     , mgr
     , ename
     , sum(sal)
  from emp
 group by grouping sets ( deptno )
     , grouping sets ( empno, () )
     , grouping sets ( (job,mgr), job, mgr, () )
     , grouping sets ( ename )
 order by deptno
     , ename
     , empno
     , job
     , mgr
/
pause
select deptno
     , empno
     , job
     , mgr
     , ename
     , sum(sal)
  from emp
 group by grouping sets ( (deptno,empno), deptno )
     , grouping sets ( (job,mgr), job, mgr, () )
     , grouping sets ( ename )
 order by deptno
     , ename
     , empno
     , job
     , mgr
/
pause
select deptno
     , empno
     , job
     , mgr
     , ename
     , sum(sal)
  from emp
 group by grouping sets
       ( (deptno,empno,job,mgr)
       , (deptno,empno,job)
       , (deptno,empno,mgr)
       , (deptno,empno)
       , (deptno,job,mgr)
       , (deptno,job)
       , (deptno,mgr)
       , deptno
       )
     , grouping sets ( ename )
 order by deptno
     , ename
     , empno
     , job
     , mgr
/
pause
select deptno
     , empno
     , job
     , mgr
     , ename
     , sum(sal)
  from emp
 group by grouping sets
       ( (deptno,ename,empno,job,mgr)
       , (deptno,ename,empno,job)
       , (deptno,ename,empno,mgr)
       , (deptno,ename,empno)
       , (deptno,ename,job,mgr)
       , (deptno,ename,job)
       , (deptno,ename,mgr)
       , (deptno,ename)
       )
 order by deptno
     , ename
     , empno
     , job
     , mgr
/
pause
select deptno
     , empno
     , job
     , mgr
     , ename
     , sum(sal)
  from emp
 group by deptno
     , ename
     , grouping sets
       ( (empno,job,mgr)
       , (empno,job)
       , (empno,mgr)
       , (empno)
       , (job,mgr)
       , job
       , mgr
       , ()
       )
 order by deptno
     , ename
     , empno
     , job
     , mgr
/
pause
select deptno
     , empno
     , job
     , mgr
     , ename
     , sum(sal)
  from emp
 group by deptno
     , ename
     , cube(empno,job,mgr)
 order by deptno
     , ename
     , empno
     , job
     , mgr
/
set echo off